// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: gps_path_tracking.proto

#define INTERNAL_SUPPRESS_PROTOBUF_FIELD_DEPRECATION
#include "gps_path_tracking.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/port.h>
#include <google/protobuf/stubs/once.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/descriptor.h>
#include <google/protobuf/generated_message_reflection.h>
#include <google/protobuf/reflection_ops.h>
#include <google/protobuf/wire_format.h>
// @@protoc_insertion_point(includes)

namespace {

const ::google::protobuf::Descriptor* GpsPoint_descriptor_ = NULL;
const ::google::protobuf::internal::GeneratedMessageReflection*
  GpsPoint_reflection_ = NULL;
const ::google::protobuf::Descriptor* GpsInfo_descriptor_ = NULL;
const ::google::protobuf::internal::GeneratedMessageReflection*
  GpsInfo_reflection_ = NULL;
const ::google::protobuf::Descriptor* GpsPathTrackingInfo_descriptor_ = NULL;
const ::google::protobuf::internal::GeneratedMessageReflection*
  GpsPathTrackingInfo_reflection_ = NULL;

}  // namespace


void protobuf_AssignDesc_gps_5fpath_5ftracking_2eproto() GOOGLE_ATTRIBUTE_COLD;
void protobuf_AssignDesc_gps_5fpath_5ftracking_2eproto() {
  protobuf_AddDesc_gps_5fpath_5ftracking_2eproto();
  const ::google::protobuf::FileDescriptor* file =
    ::google::protobuf::DescriptorPool::generated_pool()->FindFileByName(
      "gps_path_tracking.proto");
  GOOGLE_CHECK(file != NULL);
  GpsPoint_descriptor_ = file->message_type(0);
  static const int GpsPoint_offsets_[2] = {
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsPoint, lat_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsPoint, lon_),
  };
  GpsPoint_reflection_ =
    ::google::protobuf::internal::GeneratedMessageReflection::NewGeneratedMessageReflection(
      GpsPoint_descriptor_,
      GpsPoint::default_instance_,
      GpsPoint_offsets_,
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsPoint, _has_bits_[0]),
      -1,
      -1,
      sizeof(GpsPoint),
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsPoint, _internal_metadata_),
      -1);
  GpsInfo_descriptor_ = file->message_type(1);
  static const int GpsInfo_offsets_[5] = {
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsInfo, lat_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsInfo, lon_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsInfo, azi_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsInfo, speed_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsInfo, status_),
  };
  GpsInfo_reflection_ =
    ::google::protobuf::internal::GeneratedMessageReflection::NewGeneratedMessageReflection(
      GpsInfo_descriptor_,
      GpsInfo::default_instance_,
      GpsInfo_offsets_,
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsInfo, _has_bits_[0]),
      -1,
      -1,
      sizeof(GpsInfo),
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsInfo, _internal_metadata_),
      -1);
  GpsPathTrackingInfo_descriptor_ = file->message_type(2);
  static const int GpsPathTrackingInfo_offsets_[7] = {
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsPathTrackingInfo, cur_gps_point_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsPathTrackingInfo, cur_near_gps_point_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsPathTrackingInfo, pre_gps_point_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsPathTrackingInfo, pre_gps_point_azi_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsPathTrackingInfo, min_distance_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsPathTrackingInfo, finished_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsPathTrackingInfo, gps_info_),
  };
  GpsPathTrackingInfo_reflection_ =
    ::google::protobuf::internal::GeneratedMessageReflection::NewGeneratedMessageReflection(
      GpsPathTrackingInfo_descriptor_,
      GpsPathTrackingInfo::default_instance_,
      GpsPathTrackingInfo_offsets_,
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsPathTrackingInfo, _has_bits_[0]),
      -1,
      -1,
      sizeof(GpsPathTrackingInfo),
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GpsPathTrackingInfo, _internal_metadata_),
      -1);
}

namespace {

GOOGLE_PROTOBUF_DECLARE_ONCE(protobuf_AssignDescriptors_once_);
inline void protobuf_AssignDescriptorsOnce() {
  ::google::protobuf::GoogleOnceInit(&protobuf_AssignDescriptors_once_,
                 &protobuf_AssignDesc_gps_5fpath_5ftracking_2eproto);
}

void protobuf_RegisterTypes(const ::std::string&) GOOGLE_ATTRIBUTE_COLD;
void protobuf_RegisterTypes(const ::std::string&) {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedMessage(
      GpsPoint_descriptor_, &GpsPoint::default_instance());
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedMessage(
      GpsInfo_descriptor_, &GpsInfo::default_instance());
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedMessage(
      GpsPathTrackingInfo_descriptor_, &GpsPathTrackingInfo::default_instance());
}

}  // namespace

void protobuf_ShutdownFile_gps_5fpath_5ftracking_2eproto() {
  delete GpsPoint::default_instance_;
  delete GpsPoint_reflection_;
  delete GpsInfo::default_instance_;
  delete GpsInfo_reflection_;
  delete GpsPathTrackingInfo::default_instance_;
  delete GpsPathTrackingInfo_reflection_;
}

void protobuf_AddDesc_gps_5fpath_5ftracking_2eproto() GOOGLE_ATTRIBUTE_COLD;
void protobuf_AddDesc_gps_5fpath_5ftracking_2eproto() {
  static bool already_here = false;
  if (already_here) return;
  already_here = true;
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  ::google::protobuf::DescriptorPool::InternalAddGeneratedFile(
    "\n\027gps_path_tracking.proto\"$\n\010GpsPoint\022\013\n"
    "\003lat\030\001 \002(\001\022\013\n\003lon\030\002 \002(\001\"O\n\007GpsInfo\022\013\n\003la"
    "t\030\001 \002(\001\022\013\n\003lon\030\002 \002(\001\022\013\n\003azi\030\003 \002(\001\022\r\n\005spe"
    "ed\030\004 \002(\001\022\016\n\006status\030\005 \002(\r\"\337\001\n\023GpsPathTrac"
    "kingInfo\022 \n\rcur_gps_point\030\001 \003(\0132\t.GpsPoi"
    "nt\022%\n\022cur_near_gps_point\030\002 \003(\0132\t.GpsPoin"
    "t\022 \n\rpre_gps_point\030\003 \003(\0132\t.GpsPoint\022\031\n\021p"
    "re_gps_point_azi\030\004 \001(\001\022\024\n\014min_distance\030\005"
    " \001(\002\022\020\n\010finished\030\006 \001(\010\022\032\n\010gps_info\030\007 \001(\013"
    "2\010.GpsInfo", 370);
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedFile(
    "gps_path_tracking.proto", &protobuf_RegisterTypes);
  GpsPoint::default_instance_ = new GpsPoint();
  GpsInfo::default_instance_ = new GpsInfo();
  GpsPathTrackingInfo::default_instance_ = new GpsPathTrackingInfo();
  GpsPoint::default_instance_->InitAsDefaultInstance();
  GpsInfo::default_instance_->InitAsDefaultInstance();
  GpsPathTrackingInfo::default_instance_->InitAsDefaultInstance();
  ::google::protobuf::internal::OnShutdown(&protobuf_ShutdownFile_gps_5fpath_5ftracking_2eproto);
}

// Force AddDescriptors() to be called at static initialization time.
struct StaticDescriptorInitializer_gps_5fpath_5ftracking_2eproto {
  StaticDescriptorInitializer_gps_5fpath_5ftracking_2eproto() {
    protobuf_AddDesc_gps_5fpath_5ftracking_2eproto();
  }
} static_descriptor_initializer_gps_5fpath_5ftracking_2eproto_;

// ===================================================================

#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int GpsPoint::kLatFieldNumber;
const int GpsPoint::kLonFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

GpsPoint::GpsPoint()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  SharedCtor();
  // @@protoc_insertion_point(constructor:GpsPoint)
}

void GpsPoint::InitAsDefaultInstance() {
}

GpsPoint::GpsPoint(const GpsPoint& from)
  : ::google::protobuf::Message(),
    _internal_metadata_(NULL) {
  SharedCtor();
  MergeFrom(from);
  // @@protoc_insertion_point(copy_constructor:GpsPoint)
}

void GpsPoint::SharedCtor() {
  _cached_size_ = 0;
  lat_ = 0;
  lon_ = 0;
  ::memset(_has_bits_, 0, sizeof(_has_bits_));
}

GpsPoint::~GpsPoint() {
  // @@protoc_insertion_point(destructor:GpsPoint)
  SharedDtor();
}

void GpsPoint::SharedDtor() {
  if (this != default_instance_) {
  }
}

void GpsPoint::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* GpsPoint::descriptor() {
  protobuf_AssignDescriptorsOnce();
  return GpsPoint_descriptor_;
}

const GpsPoint& GpsPoint::default_instance() {
  if (default_instance_ == NULL) protobuf_AddDesc_gps_5fpath_5ftracking_2eproto();
  return *default_instance_;
}

GpsPoint* GpsPoint::default_instance_ = NULL;

GpsPoint* GpsPoint::New(::google::protobuf::Arena* arena) const {
  GpsPoint* n = new GpsPoint;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void GpsPoint::Clear() {
// @@protoc_insertion_point(message_clear_start:GpsPoint)
#if defined(__clang__)
#define ZR_HELPER_(f) \
  _Pragma("clang diagnostic push") \
  _Pragma("clang diagnostic ignored \"-Winvalid-offsetof\"") \
  __builtin_offsetof(GpsPoint, f) \
  _Pragma("clang diagnostic pop")
#else
#define ZR_HELPER_(f) reinterpret_cast<char*>(\
  &reinterpret_cast<GpsPoint*>(16)->f)
#endif

#define ZR_(first, last) do {\
  ::memset(&first, 0,\
           ZR_HELPER_(last) - ZR_HELPER_(first) + sizeof(last));\
} while (0)

  ZR_(lat_, lon_);

#undef ZR_HELPER_
#undef ZR_

  ::memset(_has_bits_, 0, sizeof(_has_bits_));
  if (_internal_metadata_.have_unknown_fields()) {
    mutable_unknown_fields()->Clear();
  }
}

bool GpsPoint::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:GpsPoint)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoff(127);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // required double lat = 1;
      case 1: {
        if (tag == 9) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   double, ::google::protobuf::internal::WireFormatLite::TYPE_DOUBLE>(
                 input, &lat_)));
          set_has_lat();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(17)) goto parse_lon;
        break;
      }

      // required double lon = 2;
      case 2: {
        if (tag == 17) {
         parse_lon:
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   double, ::google::protobuf::internal::WireFormatLite::TYPE_DOUBLE>(
                 input, &lon_)));
          set_has_lon();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectAtEnd()) goto success;
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0 ||
            ::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_END_GROUP) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:GpsPoint)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:GpsPoint)
  return false;
#undef DO_
}

void GpsPoint::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:GpsPoint)
  // required double lat = 1;
  if (has_lat()) {
    ::google::protobuf::internal::WireFormatLite::WriteDouble(1, this->lat(), output);
  }

  // required double lon = 2;
  if (has_lon()) {
    ::google::protobuf::internal::WireFormatLite::WriteDouble(2, this->lon(), output);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        unknown_fields(), output);
  }
  // @@protoc_insertion_point(serialize_end:GpsPoint)
}

::google::protobuf::uint8* GpsPoint::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  // @@protoc_insertion_point(serialize_to_array_start:GpsPoint)
  // required double lat = 1;
  if (has_lat()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteDoubleToArray(1, this->lat(), target);
  }

  // required double lon = 2;
  if (has_lon()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteDoubleToArray(2, this->lon(), target);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        unknown_fields(), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:GpsPoint)
  return target;
}

int GpsPoint::RequiredFieldsByteSizeFallback() const {
// @@protoc_insertion_point(required_fields_byte_size_fallback_start:GpsPoint)
  int total_size = 0;

  if (has_lat()) {
    // required double lat = 1;
    total_size += 1 + 8;
  }

  if (has_lon()) {
    // required double lon = 2;
    total_size += 1 + 8;
  }

  return total_size;
}
int GpsPoint::ByteSize() const {
// @@protoc_insertion_point(message_byte_size_start:GpsPoint)
  int total_size = 0;

  if (((_has_bits_[0] & 0x00000003) ^ 0x00000003) == 0) {  // All required fields are present.
    // required double lat = 1;
    total_size += 1 + 8;

    // required double lon = 2;
    total_size += 1 + 8;

  } else {
    total_size += RequiredFieldsByteSizeFallback();
  }
  if (_internal_metadata_.have_unknown_fields()) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        unknown_fields());
  }
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = total_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void GpsPoint::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:GpsPoint)
  if (GOOGLE_PREDICT_FALSE(&from == this)) {
    ::google::protobuf::internal::MergeFromFail(__FILE__, __LINE__);
  }
  const GpsPoint* source = 
      ::google::protobuf::internal::DynamicCastToGenerated<const GpsPoint>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:GpsPoint)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:GpsPoint)
    MergeFrom(*source);
  }
}

void GpsPoint::MergeFrom(const GpsPoint& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:GpsPoint)
  if (GOOGLE_PREDICT_FALSE(&from == this)) {
    ::google::protobuf::internal::MergeFromFail(__FILE__, __LINE__);
  }
  if (from._has_bits_[0 / 32] & (0xffu << (0 % 32))) {
    if (from.has_lat()) {
      set_lat(from.lat());
    }
    if (from.has_lon()) {
      set_lon(from.lon());
    }
  }
  if (from._internal_metadata_.have_unknown_fields()) {
    mutable_unknown_fields()->MergeFrom(from.unknown_fields());
  }
}

void GpsPoint::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:GpsPoint)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void GpsPoint::CopyFrom(const GpsPoint& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:GpsPoint)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool GpsPoint::IsInitialized() const {
  if ((_has_bits_[0] & 0x00000003) != 0x00000003) return false;

  return true;
}

void GpsPoint::Swap(GpsPoint* other) {
  if (other == this) return;
  InternalSwap(other);
}
void GpsPoint::InternalSwap(GpsPoint* other) {
  std::swap(lat_, other->lat_);
  std::swap(lon_, other->lon_);
  std::swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  std::swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata GpsPoint::GetMetadata() const {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::Metadata metadata;
  metadata.descriptor = GpsPoint_descriptor_;
  metadata.reflection = GpsPoint_reflection_;
  return metadata;
}

#if PROTOBUF_INLINE_NOT_IN_HEADERS
// GpsPoint

// required double lat = 1;
bool GpsPoint::has_lat() const {
  return (_has_bits_[0] & 0x00000001u) != 0;
}
void GpsPoint::set_has_lat() {
  _has_bits_[0] |= 0x00000001u;
}
void GpsPoint::clear_has_lat() {
  _has_bits_[0] &= ~0x00000001u;
}
void GpsPoint::clear_lat() {
  lat_ = 0;
  clear_has_lat();
}
 double GpsPoint::lat() const {
  // @@protoc_insertion_point(field_get:GpsPoint.lat)
  return lat_;
}
 void GpsPoint::set_lat(double value) {
  set_has_lat();
  lat_ = value;
  // @@protoc_insertion_point(field_set:GpsPoint.lat)
}

// required double lon = 2;
bool GpsPoint::has_lon() const {
  return (_has_bits_[0] & 0x00000002u) != 0;
}
void GpsPoint::set_has_lon() {
  _has_bits_[0] |= 0x00000002u;
}
void GpsPoint::clear_has_lon() {
  _has_bits_[0] &= ~0x00000002u;
}
void GpsPoint::clear_lon() {
  lon_ = 0;
  clear_has_lon();
}
 double GpsPoint::lon() const {
  // @@protoc_insertion_point(field_get:GpsPoint.lon)
  return lon_;
}
 void GpsPoint::set_lon(double value) {
  set_has_lon();
  lon_ = value;
  // @@protoc_insertion_point(field_set:GpsPoint.lon)
}

#endif  // PROTOBUF_INLINE_NOT_IN_HEADERS

// ===================================================================

#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int GpsInfo::kLatFieldNumber;
const int GpsInfo::kLonFieldNumber;
const int GpsInfo::kAziFieldNumber;
const int GpsInfo::kSpeedFieldNumber;
const int GpsInfo::kStatusFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

GpsInfo::GpsInfo()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  SharedCtor();
  // @@protoc_insertion_point(constructor:GpsInfo)
}

void GpsInfo::InitAsDefaultInstance() {
}

GpsInfo::GpsInfo(const GpsInfo& from)
  : ::google::protobuf::Message(),
    _internal_metadata_(NULL) {
  SharedCtor();
  MergeFrom(from);
  // @@protoc_insertion_point(copy_constructor:GpsInfo)
}

void GpsInfo::SharedCtor() {
  _cached_size_ = 0;
  lat_ = 0;
  lon_ = 0;
  azi_ = 0;
  speed_ = 0;
  status_ = 0u;
  ::memset(_has_bits_, 0, sizeof(_has_bits_));
}

GpsInfo::~GpsInfo() {
  // @@protoc_insertion_point(destructor:GpsInfo)
  SharedDtor();
}

void GpsInfo::SharedDtor() {
  if (this != default_instance_) {
  }
}

void GpsInfo::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* GpsInfo::descriptor() {
  protobuf_AssignDescriptorsOnce();
  return GpsInfo_descriptor_;
}

const GpsInfo& GpsInfo::default_instance() {
  if (default_instance_ == NULL) protobuf_AddDesc_gps_5fpath_5ftracking_2eproto();
  return *default_instance_;
}

GpsInfo* GpsInfo::default_instance_ = NULL;

GpsInfo* GpsInfo::New(::google::protobuf::Arena* arena) const {
  GpsInfo* n = new GpsInfo;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void GpsInfo::Clear() {
// @@protoc_insertion_point(message_clear_start:GpsInfo)
#if defined(__clang__)
#define ZR_HELPER_(f) \
  _Pragma("clang diagnostic push") \
  _Pragma("clang diagnostic ignored \"-Winvalid-offsetof\"") \
  __builtin_offsetof(GpsInfo, f) \
  _Pragma("clang diagnostic pop")
#else
#define ZR_HELPER_(f) reinterpret_cast<char*>(\
  &reinterpret_cast<GpsInfo*>(16)->f)
#endif

#define ZR_(first, last) do {\
  ::memset(&first, 0,\
           ZR_HELPER_(last) - ZR_HELPER_(first) + sizeof(last));\
} while (0)

  if (_has_bits_[0 / 32] & 31u) {
    ZR_(lat_, status_);
  }

#undef ZR_HELPER_
#undef ZR_

  ::memset(_has_bits_, 0, sizeof(_has_bits_));
  if (_internal_metadata_.have_unknown_fields()) {
    mutable_unknown_fields()->Clear();
  }
}

bool GpsInfo::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:GpsInfo)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoff(127);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // required double lat = 1;
      case 1: {
        if (tag == 9) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   double, ::google::protobuf::internal::WireFormatLite::TYPE_DOUBLE>(
                 input, &lat_)));
          set_has_lat();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(17)) goto parse_lon;
        break;
      }

      // required double lon = 2;
      case 2: {
        if (tag == 17) {
         parse_lon:
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   double, ::google::protobuf::internal::WireFormatLite::TYPE_DOUBLE>(
                 input, &lon_)));
          set_has_lon();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(25)) goto parse_azi;
        break;
      }

      // required double azi = 3;
      case 3: {
        if (tag == 25) {
         parse_azi:
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   double, ::google::protobuf::internal::WireFormatLite::TYPE_DOUBLE>(
                 input, &azi_)));
          set_has_azi();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(33)) goto parse_speed;
        break;
      }

      // required double speed = 4;
      case 4: {
        if (tag == 33) {
         parse_speed:
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   double, ::google::protobuf::internal::WireFormatLite::TYPE_DOUBLE>(
                 input, &speed_)));
          set_has_speed();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(40)) goto parse_status;
        break;
      }

      // required uint32 status = 5;
      case 5: {
        if (tag == 40) {
         parse_status:
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::uint32, ::google::protobuf::internal::WireFormatLite::TYPE_UINT32>(
                 input, &status_)));
          set_has_status();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectAtEnd()) goto success;
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0 ||
            ::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_END_GROUP) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:GpsInfo)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:GpsInfo)
  return false;
#undef DO_
}

void GpsInfo::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:GpsInfo)
  // required double lat = 1;
  if (has_lat()) {
    ::google::protobuf::internal::WireFormatLite::WriteDouble(1, this->lat(), output);
  }

  // required double lon = 2;
  if (has_lon()) {
    ::google::protobuf::internal::WireFormatLite::WriteDouble(2, this->lon(), output);
  }

  // required double azi = 3;
  if (has_azi()) {
    ::google::protobuf::internal::WireFormatLite::WriteDouble(3, this->azi(), output);
  }

  // required double speed = 4;
  if (has_speed()) {
    ::google::protobuf::internal::WireFormatLite::WriteDouble(4, this->speed(), output);
  }

  // required uint32 status = 5;
  if (has_status()) {
    ::google::protobuf::internal::WireFormatLite::WriteUInt32(5, this->status(), output);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        unknown_fields(), output);
  }
  // @@protoc_insertion_point(serialize_end:GpsInfo)
}

::google::protobuf::uint8* GpsInfo::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  // @@protoc_insertion_point(serialize_to_array_start:GpsInfo)
  // required double lat = 1;
  if (has_lat()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteDoubleToArray(1, this->lat(), target);
  }

  // required double lon = 2;
  if (has_lon()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteDoubleToArray(2, this->lon(), target);
  }

  // required double azi = 3;
  if (has_azi()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteDoubleToArray(3, this->azi(), target);
  }

  // required double speed = 4;
  if (has_speed()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteDoubleToArray(4, this->speed(), target);
  }

  // required uint32 status = 5;
  if (has_status()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteUInt32ToArray(5, this->status(), target);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        unknown_fields(), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:GpsInfo)
  return target;
}

int GpsInfo::RequiredFieldsByteSizeFallback() const {
// @@protoc_insertion_point(required_fields_byte_size_fallback_start:GpsInfo)
  int total_size = 0;

  if (has_lat()) {
    // required double lat = 1;
    total_size += 1 + 8;
  }

  if (has_lon()) {
    // required double lon = 2;
    total_size += 1 + 8;
  }

  if (has_azi()) {
    // required double azi = 3;
    total_size += 1 + 8;
  }

  if (has_speed()) {
    // required double speed = 4;
    total_size += 1 + 8;
  }

  if (has_status()) {
    // required uint32 status = 5;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->status());
  }

  return total_size;
}
int GpsInfo::ByteSize() const {
// @@protoc_insertion_point(message_byte_size_start:GpsInfo)
  int total_size = 0;

  if (((_has_bits_[0] & 0x0000001f) ^ 0x0000001f) == 0) {  // All required fields are present.
    // required double lat = 1;
    total_size += 1 + 8;

    // required double lon = 2;
    total_size += 1 + 8;

    // required double azi = 3;
    total_size += 1 + 8;

    // required double speed = 4;
    total_size += 1 + 8;

    // required uint32 status = 5;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->status());

  } else {
    total_size += RequiredFieldsByteSizeFallback();
  }
  if (_internal_metadata_.have_unknown_fields()) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        unknown_fields());
  }
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = total_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void GpsInfo::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:GpsInfo)
  if (GOOGLE_PREDICT_FALSE(&from == this)) {
    ::google::protobuf::internal::MergeFromFail(__FILE__, __LINE__);
  }
  const GpsInfo* source = 
      ::google::protobuf::internal::DynamicCastToGenerated<const GpsInfo>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:GpsInfo)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:GpsInfo)
    MergeFrom(*source);
  }
}

void GpsInfo::MergeFrom(const GpsInfo& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:GpsInfo)
  if (GOOGLE_PREDICT_FALSE(&from == this)) {
    ::google::protobuf::internal::MergeFromFail(__FILE__, __LINE__);
  }
  if (from._has_bits_[0 / 32] & (0xffu << (0 % 32))) {
    if (from.has_lat()) {
      set_lat(from.lat());
    }
    if (from.has_lon()) {
      set_lon(from.lon());
    }
    if (from.has_azi()) {
      set_azi(from.azi());
    }
    if (from.has_speed()) {
      set_speed(from.speed());
    }
    if (from.has_status()) {
      set_status(from.status());
    }
  }
  if (from._internal_metadata_.have_unknown_fields()) {
    mutable_unknown_fields()->MergeFrom(from.unknown_fields());
  }
}

void GpsInfo::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:GpsInfo)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void GpsInfo::CopyFrom(const GpsInfo& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:GpsInfo)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool GpsInfo::IsInitialized() const {
  if ((_has_bits_[0] & 0x0000001f) != 0x0000001f) return false;

  return true;
}

void GpsInfo::Swap(GpsInfo* other) {
  if (other == this) return;
  InternalSwap(other);
}
void GpsInfo::InternalSwap(GpsInfo* other) {
  std::swap(lat_, other->lat_);
  std::swap(lon_, other->lon_);
  std::swap(azi_, other->azi_);
  std::swap(speed_, other->speed_);
  std::swap(status_, other->status_);
  std::swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  std::swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata GpsInfo::GetMetadata() const {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::Metadata metadata;
  metadata.descriptor = GpsInfo_descriptor_;
  metadata.reflection = GpsInfo_reflection_;
  return metadata;
}

#if PROTOBUF_INLINE_NOT_IN_HEADERS
// GpsInfo

// required double lat = 1;
bool GpsInfo::has_lat() const {
  return (_has_bits_[0] & 0x00000001u) != 0;
}
void GpsInfo::set_has_lat() {
  _has_bits_[0] |= 0x00000001u;
}
void GpsInfo::clear_has_lat() {
  _has_bits_[0] &= ~0x00000001u;
}
void GpsInfo::clear_lat() {
  lat_ = 0;
  clear_has_lat();
}
 double GpsInfo::lat() const {
  // @@protoc_insertion_point(field_get:GpsInfo.lat)
  return lat_;
}
 void GpsInfo::set_lat(double value) {
  set_has_lat();
  lat_ = value;
  // @@protoc_insertion_point(field_set:GpsInfo.lat)
}

// required double lon = 2;
bool GpsInfo::has_lon() const {
  return (_has_bits_[0] & 0x00000002u) != 0;
}
void GpsInfo::set_has_lon() {
  _has_bits_[0] |= 0x00000002u;
}
void GpsInfo::clear_has_lon() {
  _has_bits_[0] &= ~0x00000002u;
}
void GpsInfo::clear_lon() {
  lon_ = 0;
  clear_has_lon();
}
 double GpsInfo::lon() const {
  // @@protoc_insertion_point(field_get:GpsInfo.lon)
  return lon_;
}
 void GpsInfo::set_lon(double value) {
  set_has_lon();
  lon_ = value;
  // @@protoc_insertion_point(field_set:GpsInfo.lon)
}

// required double azi = 3;
bool GpsInfo::has_azi() const {
  return (_has_bits_[0] & 0x00000004u) != 0;
}
void GpsInfo::set_has_azi() {
  _has_bits_[0] |= 0x00000004u;
}
void GpsInfo::clear_has_azi() {
  _has_bits_[0] &= ~0x00000004u;
}
void GpsInfo::clear_azi() {
  azi_ = 0;
  clear_has_azi();
}
 double GpsInfo::azi() const {
  // @@protoc_insertion_point(field_get:GpsInfo.azi)
  return azi_;
}
 void GpsInfo::set_azi(double value) {
  set_has_azi();
  azi_ = value;
  // @@protoc_insertion_point(field_set:GpsInfo.azi)
}

// required double speed = 4;
bool GpsInfo::has_speed() const {
  return (_has_bits_[0] & 0x00000008u) != 0;
}
void GpsInfo::set_has_speed() {
  _has_bits_[0] |= 0x00000008u;
}
void GpsInfo::clear_has_speed() {
  _has_bits_[0] &= ~0x00000008u;
}
void GpsInfo::clear_speed() {
  speed_ = 0;
  clear_has_speed();
}
 double GpsInfo::speed() const {
  // @@protoc_insertion_point(field_get:GpsInfo.speed)
  return speed_;
}
 void GpsInfo::set_speed(double value) {
  set_has_speed();
  speed_ = value;
  // @@protoc_insertion_point(field_set:GpsInfo.speed)
}

// required uint32 status = 5;
bool GpsInfo::has_status() const {
  return (_has_bits_[0] & 0x00000010u) != 0;
}
void GpsInfo::set_has_status() {
  _has_bits_[0] |= 0x00000010u;
}
void GpsInfo::clear_has_status() {
  _has_bits_[0] &= ~0x00000010u;
}
void GpsInfo::clear_status() {
  status_ = 0u;
  clear_has_status();
}
 ::google::protobuf::uint32 GpsInfo::status() const {
  // @@protoc_insertion_point(field_get:GpsInfo.status)
  return status_;
}
 void GpsInfo::set_status(::google::protobuf::uint32 value) {
  set_has_status();
  status_ = value;
  // @@protoc_insertion_point(field_set:GpsInfo.status)
}

#endif  // PROTOBUF_INLINE_NOT_IN_HEADERS

// ===================================================================

#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int GpsPathTrackingInfo::kCurGpsPointFieldNumber;
const int GpsPathTrackingInfo::kCurNearGpsPointFieldNumber;
const int GpsPathTrackingInfo::kPreGpsPointFieldNumber;
const int GpsPathTrackingInfo::kPreGpsPointAziFieldNumber;
const int GpsPathTrackingInfo::kMinDistanceFieldNumber;
const int GpsPathTrackingInfo::kFinishedFieldNumber;
const int GpsPathTrackingInfo::kGpsInfoFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

GpsPathTrackingInfo::GpsPathTrackingInfo()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  SharedCtor();
  // @@protoc_insertion_point(constructor:GpsPathTrackingInfo)
}

void GpsPathTrackingInfo::InitAsDefaultInstance() {
  gps_info_ = const_cast< ::GpsInfo*>(&::GpsInfo::default_instance());
}

GpsPathTrackingInfo::GpsPathTrackingInfo(const GpsPathTrackingInfo& from)
  : ::google::protobuf::Message(),
    _internal_metadata_(NULL) {
  SharedCtor();
  MergeFrom(from);
  // @@protoc_insertion_point(copy_constructor:GpsPathTrackingInfo)
}

void GpsPathTrackingInfo::SharedCtor() {
  _cached_size_ = 0;
  pre_gps_point_azi_ = 0;
  min_distance_ = 0;
  finished_ = false;
  gps_info_ = NULL;
  ::memset(_has_bits_, 0, sizeof(_has_bits_));
}

GpsPathTrackingInfo::~GpsPathTrackingInfo() {
  // @@protoc_insertion_point(destructor:GpsPathTrackingInfo)
  SharedDtor();
}

void GpsPathTrackingInfo::SharedDtor() {
  if (this != default_instance_) {
    delete gps_info_;
  }
}

void GpsPathTrackingInfo::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* GpsPathTrackingInfo::descriptor() {
  protobuf_AssignDescriptorsOnce();
  return GpsPathTrackingInfo_descriptor_;
}

const GpsPathTrackingInfo& GpsPathTrackingInfo::default_instance() {
  if (default_instance_ == NULL) protobuf_AddDesc_gps_5fpath_5ftracking_2eproto();
  return *default_instance_;
}

GpsPathTrackingInfo* GpsPathTrackingInfo::default_instance_ = NULL;

GpsPathTrackingInfo* GpsPathTrackingInfo::New(::google::protobuf::Arena* arena) const {
  GpsPathTrackingInfo* n = new GpsPathTrackingInfo;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void GpsPathTrackingInfo::Clear() {
// @@protoc_insertion_point(message_clear_start:GpsPathTrackingInfo)
#if defined(__clang__)
#define ZR_HELPER_(f) \
  _Pragma("clang diagnostic push") \
  _Pragma("clang diagnostic ignored \"-Winvalid-offsetof\"") \
  __builtin_offsetof(GpsPathTrackingInfo, f) \
  _Pragma("clang diagnostic pop")
#else
#define ZR_HELPER_(f) reinterpret_cast<char*>(\
  &reinterpret_cast<GpsPathTrackingInfo*>(16)->f)
#endif

#define ZR_(first, last) do {\
  ::memset(&first, 0,\
           ZR_HELPER_(last) - ZR_HELPER_(first) + sizeof(last));\
} while (0)

  if (_has_bits_[0 / 32] & 120u) {
    ZR_(pre_gps_point_azi_, finished_);
    if (has_gps_info()) {
      if (gps_info_ != NULL) gps_info_->::GpsInfo::Clear();
    }
  }

#undef ZR_HELPER_
#undef ZR_

  cur_gps_point_.Clear();
  cur_near_gps_point_.Clear();
  pre_gps_point_.Clear();
  ::memset(_has_bits_, 0, sizeof(_has_bits_));
  if (_internal_metadata_.have_unknown_fields()) {
    mutable_unknown_fields()->Clear();
  }
}

bool GpsPathTrackingInfo::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:GpsPathTrackingInfo)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoff(127);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated .GpsPoint cur_gps_point = 1;
      case 1: {
        if (tag == 10) {
          DO_(input->IncrementRecursionDepth());
         parse_loop_cur_gps_point:
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessageNoVirtualNoRecursionDepth(
                input, add_cur_gps_point()));
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(10)) goto parse_loop_cur_gps_point;
        if (input->ExpectTag(18)) goto parse_loop_cur_near_gps_point;
        input->UnsafeDecrementRecursionDepth();
        break;
      }

      // repeated .GpsPoint cur_near_gps_point = 2;
      case 2: {
        if (tag == 18) {
          DO_(input->IncrementRecursionDepth());
         parse_loop_cur_near_gps_point:
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessageNoVirtualNoRecursionDepth(
                input, add_cur_near_gps_point()));
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(18)) goto parse_loop_cur_near_gps_point;
        if (input->ExpectTag(26)) goto parse_loop_pre_gps_point;
        input->UnsafeDecrementRecursionDepth();
        break;
      }

      // repeated .GpsPoint pre_gps_point = 3;
      case 3: {
        if (tag == 26) {
          DO_(input->IncrementRecursionDepth());
         parse_loop_pre_gps_point:
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessageNoVirtualNoRecursionDepth(
                input, add_pre_gps_point()));
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(26)) goto parse_loop_pre_gps_point;
        input->UnsafeDecrementRecursionDepth();
        if (input->ExpectTag(33)) goto parse_pre_gps_point_azi;
        break;
      }

      // optional double pre_gps_point_azi = 4;
      case 4: {
        if (tag == 33) {
         parse_pre_gps_point_azi:
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   double, ::google::protobuf::internal::WireFormatLite::TYPE_DOUBLE>(
                 input, &pre_gps_point_azi_)));
          set_has_pre_gps_point_azi();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(45)) goto parse_min_distance;
        break;
      }

      // optional float min_distance = 5;
      case 5: {
        if (tag == 45) {
         parse_min_distance:
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   float, ::google::protobuf::internal::WireFormatLite::TYPE_FLOAT>(
                 input, &min_distance_)));
          set_has_min_distance();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(48)) goto parse_finished;
        break;
      }

      // optional bool finished = 6;
      case 6: {
        if (tag == 48) {
         parse_finished:
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, &finished_)));
          set_has_finished();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(58)) goto parse_gps_info;
        break;
      }

      // optional .GpsInfo gps_info = 7;
      case 7: {
        if (tag == 58) {
         parse_gps_info:
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessageNoVirtual(
               input, mutable_gps_info()));
        } else {
          goto handle_unusual;
        }
        if (input->ExpectAtEnd()) goto success;
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0 ||
            ::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_END_GROUP) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:GpsPathTrackingInfo)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:GpsPathTrackingInfo)
  return false;
#undef DO_
}

void GpsPathTrackingInfo::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:GpsPathTrackingInfo)
  // repeated .GpsPoint cur_gps_point = 1;
  for (unsigned int i = 0, n = this->cur_gps_point_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      1, this->cur_gps_point(i), output);
  }

  // repeated .GpsPoint cur_near_gps_point = 2;
  for (unsigned int i = 0, n = this->cur_near_gps_point_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      2, this->cur_near_gps_point(i), output);
  }

  // repeated .GpsPoint pre_gps_point = 3;
  for (unsigned int i = 0, n = this->pre_gps_point_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      3, this->pre_gps_point(i), output);
  }

  // optional double pre_gps_point_azi = 4;
  if (has_pre_gps_point_azi()) {
    ::google::protobuf::internal::WireFormatLite::WriteDouble(4, this->pre_gps_point_azi(), output);
  }

  // optional float min_distance = 5;
  if (has_min_distance()) {
    ::google::protobuf::internal::WireFormatLite::WriteFloat(5, this->min_distance(), output);
  }

  // optional bool finished = 6;
  if (has_finished()) {
    ::google::protobuf::internal::WireFormatLite::WriteBool(6, this->finished(), output);
  }

  // optional .GpsInfo gps_info = 7;
  if (has_gps_info()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      7, *this->gps_info_, output);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        unknown_fields(), output);
  }
  // @@protoc_insertion_point(serialize_end:GpsPathTrackingInfo)
}

::google::protobuf::uint8* GpsPathTrackingInfo::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  // @@protoc_insertion_point(serialize_to_array_start:GpsPathTrackingInfo)
  // repeated .GpsPoint cur_gps_point = 1;
  for (unsigned int i = 0, n = this->cur_gps_point_size(); i < n; i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageNoVirtualToArray(
        1, this->cur_gps_point(i), false, target);
  }

  // repeated .GpsPoint cur_near_gps_point = 2;
  for (unsigned int i = 0, n = this->cur_near_gps_point_size(); i < n; i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageNoVirtualToArray(
        2, this->cur_near_gps_point(i), false, target);
  }

  // repeated .GpsPoint pre_gps_point = 3;
  for (unsigned int i = 0, n = this->pre_gps_point_size(); i < n; i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageNoVirtualToArray(
        3, this->pre_gps_point(i), false, target);
  }

  // optional double pre_gps_point_azi = 4;
  if (has_pre_gps_point_azi()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteDoubleToArray(4, this->pre_gps_point_azi(), target);
  }

  // optional float min_distance = 5;
  if (has_min_distance()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteFloatToArray(5, this->min_distance(), target);
  }

  // optional bool finished = 6;
  if (has_finished()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteBoolToArray(6, this->finished(), target);
  }

  // optional .GpsInfo gps_info = 7;
  if (has_gps_info()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageNoVirtualToArray(
        7, *this->gps_info_, false, target);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        unknown_fields(), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:GpsPathTrackingInfo)
  return target;
}

int GpsPathTrackingInfo::ByteSize() const {
// @@protoc_insertion_point(message_byte_size_start:GpsPathTrackingInfo)
  int total_size = 0;

  if (_has_bits_[3 / 32] & 120u) {
    // optional double pre_gps_point_azi = 4;
    if (has_pre_gps_point_azi()) {
      total_size += 1 + 8;
    }

    // optional float min_distance = 5;
    if (has_min_distance()) {
      total_size += 1 + 4;
    }

    // optional bool finished = 6;
    if (has_finished()) {
      total_size += 1 + 1;
    }

    // optional .GpsInfo gps_info = 7;
    if (has_gps_info()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::MessageSizeNoVirtual(
          *this->gps_info_);
    }

  }
  // repeated .GpsPoint cur_gps_point = 1;
  total_size += 1 * this->cur_gps_point_size();
  for (int i = 0; i < this->cur_gps_point_size(); i++) {
    total_size +=
      ::google::protobuf::internal::WireFormatLite::MessageSizeNoVirtual(
        this->cur_gps_point(i));
  }

  // repeated .GpsPoint cur_near_gps_point = 2;
  total_size += 1 * this->cur_near_gps_point_size();
  for (int i = 0; i < this->cur_near_gps_point_size(); i++) {
    total_size +=
      ::google::protobuf::internal::WireFormatLite::MessageSizeNoVirtual(
        this->cur_near_gps_point(i));
  }

  // repeated .GpsPoint pre_gps_point = 3;
  total_size += 1 * this->pre_gps_point_size();
  for (int i = 0; i < this->pre_gps_point_size(); i++) {
    total_size +=
      ::google::protobuf::internal::WireFormatLite::MessageSizeNoVirtual(
        this->pre_gps_point(i));
  }

  if (_internal_metadata_.have_unknown_fields()) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        unknown_fields());
  }
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = total_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void GpsPathTrackingInfo::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:GpsPathTrackingInfo)
  if (GOOGLE_PREDICT_FALSE(&from == this)) {
    ::google::protobuf::internal::MergeFromFail(__FILE__, __LINE__);
  }
  const GpsPathTrackingInfo* source = 
      ::google::protobuf::internal::DynamicCastToGenerated<const GpsPathTrackingInfo>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:GpsPathTrackingInfo)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:GpsPathTrackingInfo)
    MergeFrom(*source);
  }
}

void GpsPathTrackingInfo::MergeFrom(const GpsPathTrackingInfo& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:GpsPathTrackingInfo)
  if (GOOGLE_PREDICT_FALSE(&from == this)) {
    ::google::protobuf::internal::MergeFromFail(__FILE__, __LINE__);
  }
  cur_gps_point_.MergeFrom(from.cur_gps_point_);
  cur_near_gps_point_.MergeFrom(from.cur_near_gps_point_);
  pre_gps_point_.MergeFrom(from.pre_gps_point_);
  if (from._has_bits_[3 / 32] & (0xffu << (3 % 32))) {
    if (from.has_pre_gps_point_azi()) {
      set_pre_gps_point_azi(from.pre_gps_point_azi());
    }
    if (from.has_min_distance()) {
      set_min_distance(from.min_distance());
    }
    if (from.has_finished()) {
      set_finished(from.finished());
    }
    if (from.has_gps_info()) {
      mutable_gps_info()->::GpsInfo::MergeFrom(from.gps_info());
    }
  }
  if (from._internal_metadata_.have_unknown_fields()) {
    mutable_unknown_fields()->MergeFrom(from.unknown_fields());
  }
}

void GpsPathTrackingInfo::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:GpsPathTrackingInfo)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void GpsPathTrackingInfo::CopyFrom(const GpsPathTrackingInfo& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:GpsPathTrackingInfo)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool GpsPathTrackingInfo::IsInitialized() const {

  if (!::google::protobuf::internal::AllAreInitialized(this->cur_gps_point())) return false;
  if (!::google::protobuf::internal::AllAreInitialized(this->cur_near_gps_point())) return false;
  if (!::google::protobuf::internal::AllAreInitialized(this->pre_gps_point())) return false;
  if (has_gps_info()) {
    if (!this->gps_info_->IsInitialized()) return false;
  }
  return true;
}

void GpsPathTrackingInfo::Swap(GpsPathTrackingInfo* other) {
  if (other == this) return;
  InternalSwap(other);
}
void GpsPathTrackingInfo::InternalSwap(GpsPathTrackingInfo* other) {
  cur_gps_point_.UnsafeArenaSwap(&other->cur_gps_point_);
  cur_near_gps_point_.UnsafeArenaSwap(&other->cur_near_gps_point_);
  pre_gps_point_.UnsafeArenaSwap(&other->pre_gps_point_);
  std::swap(pre_gps_point_azi_, other->pre_gps_point_azi_);
  std::swap(min_distance_, other->min_distance_);
  std::swap(finished_, other->finished_);
  std::swap(gps_info_, other->gps_info_);
  std::swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  std::swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata GpsPathTrackingInfo::GetMetadata() const {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::Metadata metadata;
  metadata.descriptor = GpsPathTrackingInfo_descriptor_;
  metadata.reflection = GpsPathTrackingInfo_reflection_;
  return metadata;
}

#if PROTOBUF_INLINE_NOT_IN_HEADERS
// GpsPathTrackingInfo

// repeated .GpsPoint cur_gps_point = 1;
int GpsPathTrackingInfo::cur_gps_point_size() const {
  return cur_gps_point_.size();
}
void GpsPathTrackingInfo::clear_cur_gps_point() {
  cur_gps_point_.Clear();
}
const ::GpsPoint& GpsPathTrackingInfo::cur_gps_point(int index) const {
  // @@protoc_insertion_point(field_get:GpsPathTrackingInfo.cur_gps_point)
  return cur_gps_point_.Get(index);
}
::GpsPoint* GpsPathTrackingInfo::mutable_cur_gps_point(int index) {
  // @@protoc_insertion_point(field_mutable:GpsPathTrackingInfo.cur_gps_point)
  return cur_gps_point_.Mutable(index);
}
::GpsPoint* GpsPathTrackingInfo::add_cur_gps_point() {
  // @@protoc_insertion_point(field_add:GpsPathTrackingInfo.cur_gps_point)
  return cur_gps_point_.Add();
}
::google::protobuf::RepeatedPtrField< ::GpsPoint >*
GpsPathTrackingInfo::mutable_cur_gps_point() {
  // @@protoc_insertion_point(field_mutable_list:GpsPathTrackingInfo.cur_gps_point)
  return &cur_gps_point_;
}
const ::google::protobuf::RepeatedPtrField< ::GpsPoint >&
GpsPathTrackingInfo::cur_gps_point() const {
  // @@protoc_insertion_point(field_list:GpsPathTrackingInfo.cur_gps_point)
  return cur_gps_point_;
}

// repeated .GpsPoint cur_near_gps_point = 2;
int GpsPathTrackingInfo::cur_near_gps_point_size() const {
  return cur_near_gps_point_.size();
}
void GpsPathTrackingInfo::clear_cur_near_gps_point() {
  cur_near_gps_point_.Clear();
}
const ::GpsPoint& GpsPathTrackingInfo::cur_near_gps_point(int index) const {
  // @@protoc_insertion_point(field_get:GpsPathTrackingInfo.cur_near_gps_point)
  return cur_near_gps_point_.Get(index);
}
::GpsPoint* GpsPathTrackingInfo::mutable_cur_near_gps_point(int index) {
  // @@protoc_insertion_point(field_mutable:GpsPathTrackingInfo.cur_near_gps_point)
  return cur_near_gps_point_.Mutable(index);
}
::GpsPoint* GpsPathTrackingInfo::add_cur_near_gps_point() {
  // @@protoc_insertion_point(field_add:GpsPathTrackingInfo.cur_near_gps_point)
  return cur_near_gps_point_.Add();
}
::google::protobuf::RepeatedPtrField< ::GpsPoint >*
GpsPathTrackingInfo::mutable_cur_near_gps_point() {
  // @@protoc_insertion_point(field_mutable_list:GpsPathTrackingInfo.cur_near_gps_point)
  return &cur_near_gps_point_;
}
const ::google::protobuf::RepeatedPtrField< ::GpsPoint >&
GpsPathTrackingInfo::cur_near_gps_point() const {
  // @@protoc_insertion_point(field_list:GpsPathTrackingInfo.cur_near_gps_point)
  return cur_near_gps_point_;
}

// repeated .GpsPoint pre_gps_point = 3;
int GpsPathTrackingInfo::pre_gps_point_size() const {
  return pre_gps_point_.size();
}
void GpsPathTrackingInfo::clear_pre_gps_point() {
  pre_gps_point_.Clear();
}
const ::GpsPoint& GpsPathTrackingInfo::pre_gps_point(int index) const {
  // @@protoc_insertion_point(field_get:GpsPathTrackingInfo.pre_gps_point)
  return pre_gps_point_.Get(index);
}
::GpsPoint* GpsPathTrackingInfo::mutable_pre_gps_point(int index) {
  // @@protoc_insertion_point(field_mutable:GpsPathTrackingInfo.pre_gps_point)
  return pre_gps_point_.Mutable(index);
}
::GpsPoint* GpsPathTrackingInfo::add_pre_gps_point() {
  // @@protoc_insertion_point(field_add:GpsPathTrackingInfo.pre_gps_point)
  return pre_gps_point_.Add();
}
::google::protobuf::RepeatedPtrField< ::GpsPoint >*
GpsPathTrackingInfo::mutable_pre_gps_point() {
  // @@protoc_insertion_point(field_mutable_list:GpsPathTrackingInfo.pre_gps_point)
  return &pre_gps_point_;
}
const ::google::protobuf::RepeatedPtrField< ::GpsPoint >&
GpsPathTrackingInfo::pre_gps_point() const {
  // @@protoc_insertion_point(field_list:GpsPathTrackingInfo.pre_gps_point)
  return pre_gps_point_;
}

// optional double pre_gps_point_azi = 4;
bool GpsPathTrackingInfo::has_pre_gps_point_azi() const {
  return (_has_bits_[0] & 0x00000008u) != 0;
}
void GpsPathTrackingInfo::set_has_pre_gps_point_azi() {
  _has_bits_[0] |= 0x00000008u;
}
void GpsPathTrackingInfo::clear_has_pre_gps_point_azi() {
  _has_bits_[0] &= ~0x00000008u;
}
void GpsPathTrackingInfo::clear_pre_gps_point_azi() {
  pre_gps_point_azi_ = 0;
  clear_has_pre_gps_point_azi();
}
 double GpsPathTrackingInfo::pre_gps_point_azi() const {
  // @@protoc_insertion_point(field_get:GpsPathTrackingInfo.pre_gps_point_azi)
  return pre_gps_point_azi_;
}
 void GpsPathTrackingInfo::set_pre_gps_point_azi(double value) {
  set_has_pre_gps_point_azi();
  pre_gps_point_azi_ = value;
  // @@protoc_insertion_point(field_set:GpsPathTrackingInfo.pre_gps_point_azi)
}

// optional float min_distance = 5;
bool GpsPathTrackingInfo::has_min_distance() const {
  return (_has_bits_[0] & 0x00000010u) != 0;
}
void GpsPathTrackingInfo::set_has_min_distance() {
  _has_bits_[0] |= 0x00000010u;
}
void GpsPathTrackingInfo::clear_has_min_distance() {
  _has_bits_[0] &= ~0x00000010u;
}
void GpsPathTrackingInfo::clear_min_distance() {
  min_distance_ = 0;
  clear_has_min_distance();
}
 float GpsPathTrackingInfo::min_distance() const {
  // @@protoc_insertion_point(field_get:GpsPathTrackingInfo.min_distance)
  return min_distance_;
}
 void GpsPathTrackingInfo::set_min_distance(float value) {
  set_has_min_distance();
  min_distance_ = value;
  // @@protoc_insertion_point(field_set:GpsPathTrackingInfo.min_distance)
}

// optional bool finished = 6;
bool GpsPathTrackingInfo::has_finished() const {
  return (_has_bits_[0] & 0x00000020u) != 0;
}
void GpsPathTrackingInfo::set_has_finished() {
  _has_bits_[0] |= 0x00000020u;
}
void GpsPathTrackingInfo::clear_has_finished() {
  _has_bits_[0] &= ~0x00000020u;
}
void GpsPathTrackingInfo::clear_finished() {
  finished_ = false;
  clear_has_finished();
}
 bool GpsPathTrackingInfo::finished() const {
  // @@protoc_insertion_point(field_get:GpsPathTrackingInfo.finished)
  return finished_;
}
 void GpsPathTrackingInfo::set_finished(bool value) {
  set_has_finished();
  finished_ = value;
  // @@protoc_insertion_point(field_set:GpsPathTrackingInfo.finished)
}

// optional .GpsInfo gps_info = 7;
bool GpsPathTrackingInfo::has_gps_info() const {
  return (_has_bits_[0] & 0x00000040u) != 0;
}
void GpsPathTrackingInfo::set_has_gps_info() {
  _has_bits_[0] |= 0x00000040u;
}
void GpsPathTrackingInfo::clear_has_gps_info() {
  _has_bits_[0] &= ~0x00000040u;
}
void GpsPathTrackingInfo::clear_gps_info() {
  if (gps_info_ != NULL) gps_info_->::GpsInfo::Clear();
  clear_has_gps_info();
}
const ::GpsInfo& GpsPathTrackingInfo::gps_info() const {
  // @@protoc_insertion_point(field_get:GpsPathTrackingInfo.gps_info)
  return gps_info_ != NULL ? *gps_info_ : *default_instance_->gps_info_;
}
::GpsInfo* GpsPathTrackingInfo::mutable_gps_info() {
  set_has_gps_info();
  if (gps_info_ == NULL) {
    gps_info_ = new ::GpsInfo;
  }
  // @@protoc_insertion_point(field_mutable:GpsPathTrackingInfo.gps_info)
  return gps_info_;
}
::GpsInfo* GpsPathTrackingInfo::release_gps_info() {
  // @@protoc_insertion_point(field_release:GpsPathTrackingInfo.gps_info)
  clear_has_gps_info();
  ::GpsInfo* temp = gps_info_;
  gps_info_ = NULL;
  return temp;
}
void GpsPathTrackingInfo::set_allocated_gps_info(::GpsInfo* gps_info) {
  delete gps_info_;
  gps_info_ = gps_info;
  if (gps_info) {
    set_has_gps_info();
  } else {
    clear_has_gps_info();
  }
  // @@protoc_insertion_point(field_set_allocated:GpsPathTrackingInfo.gps_info)
}

#endif  // PROTOBUF_INLINE_NOT_IN_HEADERS

// @@protoc_insertion_point(namespace_scope)

// @@protoc_insertion_point(global_scope)
